// Code generated by gotdgen, DO NOT EDIT.

package tdapi

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// ChangePhoneNumberRequest represents TL type `changePhoneNumber#f891bba3`.
type ChangePhoneNumberRequest struct {
	// The new phone number of the user in international format
	PhoneNumber string
	// Settings for the authentication of the user's phone number; pass null to use default
	// settings
	Settings PhoneNumberAuthenticationSettings
}

// ChangePhoneNumberRequestTypeID is TL type id of ChangePhoneNumberRequest.
const ChangePhoneNumberRequestTypeID = 0xf891bba3

// Ensuring interfaces in compile-time for ChangePhoneNumberRequest.
var (
	_ bin.Encoder     = &ChangePhoneNumberRequest{}
	_ bin.Decoder     = &ChangePhoneNumberRequest{}
	_ bin.BareEncoder = &ChangePhoneNumberRequest{}
	_ bin.BareDecoder = &ChangePhoneNumberRequest{}
)

func (c *ChangePhoneNumberRequest) Zero() bool {
	if c == nil {
		return true
	}
	if !(c.PhoneNumber == "") {
		return false
	}
	if !(c.Settings.Zero()) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (c *ChangePhoneNumberRequest) String() string {
	if c == nil {
		return "ChangePhoneNumberRequest(nil)"
	}
	type Alias ChangePhoneNumberRequest
	return fmt.Sprintf("ChangePhoneNumberRequest%+v", Alias(*c))
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*ChangePhoneNumberRequest) TypeID() uint32 {
	return ChangePhoneNumberRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*ChangePhoneNumberRequest) TypeName() string {
	return "changePhoneNumber"
}

// TypeInfo returns info about TL type.
func (c *ChangePhoneNumberRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "changePhoneNumber",
		ID:   ChangePhoneNumberRequestTypeID,
	}
	if c == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "PhoneNumber",
			SchemaName: "phone_number",
		},
		{
			Name:       "Settings",
			SchemaName: "settings",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (c *ChangePhoneNumberRequest) Encode(b *bin.Buffer) error {
	if c == nil {
		return fmt.Errorf("can't encode changePhoneNumber#f891bba3 as nil")
	}
	b.PutID(ChangePhoneNumberRequestTypeID)
	return c.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (c *ChangePhoneNumberRequest) EncodeBare(b *bin.Buffer) error {
	if c == nil {
		return fmt.Errorf("can't encode changePhoneNumber#f891bba3 as nil")
	}
	b.PutString(c.PhoneNumber)
	if err := c.Settings.Encode(b); err != nil {
		return fmt.Errorf("unable to encode changePhoneNumber#f891bba3: field settings: %w", err)
	}
	return nil
}

// Decode implements bin.Decoder.
func (c *ChangePhoneNumberRequest) Decode(b *bin.Buffer) error {
	if c == nil {
		return fmt.Errorf("can't decode changePhoneNumber#f891bba3 to nil")
	}
	if err := b.ConsumeID(ChangePhoneNumberRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode changePhoneNumber#f891bba3: %w", err)
	}
	return c.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (c *ChangePhoneNumberRequest) DecodeBare(b *bin.Buffer) error {
	if c == nil {
		return fmt.Errorf("can't decode changePhoneNumber#f891bba3 to nil")
	}
	{
		value, err := b.String()
		if err != nil {
			return fmt.Errorf("unable to decode changePhoneNumber#f891bba3: field phone_number: %w", err)
		}
		c.PhoneNumber = value
	}
	{
		if err := c.Settings.Decode(b); err != nil {
			return fmt.Errorf("unable to decode changePhoneNumber#f891bba3: field settings: %w", err)
		}
	}
	return nil
}

// EncodeTDLibJSON implements tdjson.TDLibEncoder.
func (c *ChangePhoneNumberRequest) EncodeTDLibJSON(b tdjson.Encoder) error {
	if c == nil {
		return fmt.Errorf("can't encode changePhoneNumber#f891bba3 as nil")
	}
	b.ObjStart()
	b.PutID("changePhoneNumber")
	b.Comma()
	b.FieldStart("phone_number")
	b.PutString(c.PhoneNumber)
	b.Comma()
	b.FieldStart("settings")
	if err := c.Settings.EncodeTDLibJSON(b); err != nil {
		return fmt.Errorf("unable to encode changePhoneNumber#f891bba3: field settings: %w", err)
	}
	b.Comma()
	b.StripComma()
	b.ObjEnd()
	return nil
}

// DecodeTDLibJSON implements tdjson.TDLibDecoder.
func (c *ChangePhoneNumberRequest) DecodeTDLibJSON(b tdjson.Decoder) error {
	if c == nil {
		return fmt.Errorf("can't decode changePhoneNumber#f891bba3 to nil")
	}

	return b.Obj(func(b tdjson.Decoder, key []byte) error {
		switch string(key) {
		case tdjson.TypeField:
			if err := b.ConsumeID("changePhoneNumber"); err != nil {
				return fmt.Errorf("unable to decode changePhoneNumber#f891bba3: %w", err)
			}
		case "phone_number":
			value, err := b.String()
			if err != nil {
				return fmt.Errorf("unable to decode changePhoneNumber#f891bba3: field phone_number: %w", err)
			}
			c.PhoneNumber = value
		case "settings":
			if err := c.Settings.DecodeTDLibJSON(b); err != nil {
				return fmt.Errorf("unable to decode changePhoneNumber#f891bba3: field settings: %w", err)
			}
		default:
			return b.Skip()
		}
		return nil
	})
}

// GetPhoneNumber returns value of PhoneNumber field.
func (c *ChangePhoneNumberRequest) GetPhoneNumber() (value string) {
	if c == nil {
		return
	}
	return c.PhoneNumber
}

// GetSettings returns value of Settings field.
func (c *ChangePhoneNumberRequest) GetSettings() (value PhoneNumberAuthenticationSettings) {
	if c == nil {
		return
	}
	return c.Settings
}

// ChangePhoneNumber invokes method changePhoneNumber#f891bba3 returning error if any.
func (c *Client) ChangePhoneNumber(ctx context.Context, request *ChangePhoneNumberRequest) (*AuthenticationCodeInfo, error) {
	var result AuthenticationCodeInfo

	if err := c.rpc.Invoke(ctx, request, &result); err != nil {
		return nil, err
	}
	return &result, nil
}
