// Code generated by gotdgen, DO NOT EDIT.

package tdapi

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// MessageReaction represents TL type `messageReaction#7c4179cb`.
type MessageReaction struct {
	// Text representation of the reaction
	Reaction string
	// Number of times the reaction was added
	TotalCount int32
	// True, if the reaction is chosen by the current user
	IsChosen bool
	// Identifiers of at most 3 recent message senders, added the reaction; available in
	// private, basic group and supergroup chats
	RecentSenderIDs []MessageSenderClass
}

// MessageReactionTypeID is TL type id of MessageReaction.
const MessageReactionTypeID = 0x7c4179cb

// Ensuring interfaces in compile-time for MessageReaction.
var (
	_ bin.Encoder     = &MessageReaction{}
	_ bin.Decoder     = &MessageReaction{}
	_ bin.BareEncoder = &MessageReaction{}
	_ bin.BareDecoder = &MessageReaction{}
)

func (m *MessageReaction) Zero() bool {
	if m == nil {
		return true
	}
	if !(m.Reaction == "") {
		return false
	}
	if !(m.TotalCount == 0) {
		return false
	}
	if !(m.IsChosen == false) {
		return false
	}
	if !(m.RecentSenderIDs == nil) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (m *MessageReaction) String() string {
	if m == nil {
		return "MessageReaction(nil)"
	}
	type Alias MessageReaction
	return fmt.Sprintf("MessageReaction%+v", Alias(*m))
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*MessageReaction) TypeID() uint32 {
	return MessageReactionTypeID
}

// TypeName returns name of type in TL schema.
func (*MessageReaction) TypeName() string {
	return "messageReaction"
}

// TypeInfo returns info about TL type.
func (m *MessageReaction) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "messageReaction",
		ID:   MessageReactionTypeID,
	}
	if m == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "Reaction",
			SchemaName: "reaction",
		},
		{
			Name:       "TotalCount",
			SchemaName: "total_count",
		},
		{
			Name:       "IsChosen",
			SchemaName: "is_chosen",
		},
		{
			Name:       "RecentSenderIDs",
			SchemaName: "recent_sender_ids",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (m *MessageReaction) Encode(b *bin.Buffer) error {
	if m == nil {
		return fmt.Errorf("can't encode messageReaction#7c4179cb as nil")
	}
	b.PutID(MessageReactionTypeID)
	return m.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (m *MessageReaction) EncodeBare(b *bin.Buffer) error {
	if m == nil {
		return fmt.Errorf("can't encode messageReaction#7c4179cb as nil")
	}
	b.PutString(m.Reaction)
	b.PutInt32(m.TotalCount)
	b.PutBool(m.IsChosen)
	b.PutInt(len(m.RecentSenderIDs))
	for idx, v := range m.RecentSenderIDs {
		if v == nil {
			return fmt.Errorf("unable to encode messageReaction#7c4179cb: field recent_sender_ids element with index %d is nil", idx)
		}
		if err := v.EncodeBare(b); err != nil {
			return fmt.Errorf("unable to encode bare messageReaction#7c4179cb: field recent_sender_ids element with index %d: %w", idx, err)
		}
	}
	return nil
}

// Decode implements bin.Decoder.
func (m *MessageReaction) Decode(b *bin.Buffer) error {
	if m == nil {
		return fmt.Errorf("can't decode messageReaction#7c4179cb to nil")
	}
	if err := b.ConsumeID(MessageReactionTypeID); err != nil {
		return fmt.Errorf("unable to decode messageReaction#7c4179cb: %w", err)
	}
	return m.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (m *MessageReaction) DecodeBare(b *bin.Buffer) error {
	if m == nil {
		return fmt.Errorf("can't decode messageReaction#7c4179cb to nil")
	}
	{
		value, err := b.String()
		if err != nil {
			return fmt.Errorf("unable to decode messageReaction#7c4179cb: field reaction: %w", err)
		}
		m.Reaction = value
	}
	{
		value, err := b.Int32()
		if err != nil {
			return fmt.Errorf("unable to decode messageReaction#7c4179cb: field total_count: %w", err)
		}
		m.TotalCount = value
	}
	{
		value, err := b.Bool()
		if err != nil {
			return fmt.Errorf("unable to decode messageReaction#7c4179cb: field is_chosen: %w", err)
		}
		m.IsChosen = value
	}
	{
		headerLen, err := b.Int()
		if err != nil {
			return fmt.Errorf("unable to decode messageReaction#7c4179cb: field recent_sender_ids: %w", err)
		}

		if headerLen > 0 {
			m.RecentSenderIDs = make([]MessageSenderClass, 0, headerLen%bin.PreallocateLimit)
		}
		for idx := 0; idx < headerLen; idx++ {
			value, err := DecodeMessageSender(b)
			if err != nil {
				return fmt.Errorf("unable to decode messageReaction#7c4179cb: field recent_sender_ids: %w", err)
			}
			m.RecentSenderIDs = append(m.RecentSenderIDs, value)
		}
	}
	return nil
}

// EncodeTDLibJSON implements tdjson.TDLibEncoder.
func (m *MessageReaction) EncodeTDLibJSON(b tdjson.Encoder) error {
	if m == nil {
		return fmt.Errorf("can't encode messageReaction#7c4179cb as nil")
	}
	b.ObjStart()
	b.PutID("messageReaction")
	b.Comma()
	b.FieldStart("reaction")
	b.PutString(m.Reaction)
	b.Comma()
	b.FieldStart("total_count")
	b.PutInt32(m.TotalCount)
	b.Comma()
	b.FieldStart("is_chosen")
	b.PutBool(m.IsChosen)
	b.Comma()
	b.FieldStart("recent_sender_ids")
	b.ArrStart()
	for idx, v := range m.RecentSenderIDs {
		if v == nil {
			return fmt.Errorf("unable to encode messageReaction#7c4179cb: field recent_sender_ids element with index %d is nil", idx)
		}
		if err := v.EncodeTDLibJSON(b); err != nil {
			return fmt.Errorf("unable to encode messageReaction#7c4179cb: field recent_sender_ids element with index %d: %w", idx, err)
		}
		b.Comma()
	}
	b.StripComma()
	b.ArrEnd()
	b.Comma()
	b.StripComma()
	b.ObjEnd()
	return nil
}

// DecodeTDLibJSON implements tdjson.TDLibDecoder.
func (m *MessageReaction) DecodeTDLibJSON(b tdjson.Decoder) error {
	if m == nil {
		return fmt.Errorf("can't decode messageReaction#7c4179cb to nil")
	}

	return b.Obj(func(b tdjson.Decoder, key []byte) error {
		switch string(key) {
		case tdjson.TypeField:
			if err := b.ConsumeID("messageReaction"); err != nil {
				return fmt.Errorf("unable to decode messageReaction#7c4179cb: %w", err)
			}
		case "reaction":
			value, err := b.String()
			if err != nil {
				return fmt.Errorf("unable to decode messageReaction#7c4179cb: field reaction: %w", err)
			}
			m.Reaction = value
		case "total_count":
			value, err := b.Int32()
			if err != nil {
				return fmt.Errorf("unable to decode messageReaction#7c4179cb: field total_count: %w", err)
			}
			m.TotalCount = value
		case "is_chosen":
			value, err := b.Bool()
			if err != nil {
				return fmt.Errorf("unable to decode messageReaction#7c4179cb: field is_chosen: %w", err)
			}
			m.IsChosen = value
		case "recent_sender_ids":
			if err := b.Arr(func(b tdjson.Decoder) error {
				value, err := DecodeTDLibJSONMessageSender(b)
				if err != nil {
					return fmt.Errorf("unable to decode messageReaction#7c4179cb: field recent_sender_ids: %w", err)
				}
				m.RecentSenderIDs = append(m.RecentSenderIDs, value)
				return nil
			}); err != nil {
				return fmt.Errorf("unable to decode messageReaction#7c4179cb: field recent_sender_ids: %w", err)
			}
		default:
			return b.Skip()
		}
		return nil
	})
}

// GetReaction returns value of Reaction field.
func (m *MessageReaction) GetReaction() (value string) {
	if m == nil {
		return
	}
	return m.Reaction
}

// GetTotalCount returns value of TotalCount field.
func (m *MessageReaction) GetTotalCount() (value int32) {
	if m == nil {
		return
	}
	return m.TotalCount
}

// GetIsChosen returns value of IsChosen field.
func (m *MessageReaction) GetIsChosen() (value bool) {
	if m == nil {
		return
	}
	return m.IsChosen
}

// GetRecentSenderIDs returns value of RecentSenderIDs field.
func (m *MessageReaction) GetRecentSenderIDs() (value []MessageSenderClass) {
	if m == nil {
		return
	}
	return m.RecentSenderIDs
}
